#include "mcu_wrapper_conf.h"

#ifndef ADC_SIM
#define ADC_SIM

//   ADC
typedef struct
{
	int tAdc;
	int Tadc;
	int nAdc;

	int norma_adc;
	double adc_amplitude;
	int adc_bit_depth;
}AdcConvertionHandle;

//    
typedef struct
{
	double udc1;
	double udc2;
	double ia1;
	double ib1;
	double ic1;
	double ia2;
	double ib2;
	double ic2;
	double wm;
}AdcRealMeasureHandle;


//    
typedef struct
{
	int adc_val;

	double real_satur;
	int r_adc;
	int k_lem_adc;
	int offset;

}AdcMeasureHandle;


typedef struct
{
	AdcConvertionHandle		convertion;
	AdcRealMeasureHandle	Measure;
	AdcMeasureHandle		udc1;
	AdcMeasureHandle		udc2;
	AdcMeasureHandle		ia1;
	AdcMeasureHandle		ib1;
	AdcMeasureHandle		ic1;
	AdcMeasureHandle		ia2;
	AdcMeasureHandle		ib2;
	AdcMeasureHandle		ic2;
	AdcMeasureHandle		wm;
}AdcSimHandle;
AdcSimHandle AdcSim;



void Simulate_ADC(SimStruct* S);
void Init_ADC_Simulation();

void adcInitConvertion(AdcConvertionHandle* hconv, int norma_adc, double adc_amplitude, int adc_bit_depth);
void adcInitMeasure(AdcMeasureHandle* hmeasure, int k_lem_adc, int r_adc, int offset, double real_satur);

void adcMeasure(AdcRealMeasureHandle* hrmeasure, const real_T* u, int startind);
void adcConvert(AdcConvertionHandle* hconv, AdcMeasureHandle* hmeasure, double realMeasure);

#endif //PWM_SIM
